# coding: utf-8

"""
    Pluggy API

    Pluggy's main API to review data and execute connectors

    The version of the OpenAPI document: 1.0.0
    Contact: hello@pluggy.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Address(BaseModel):
    """
    The address object contains data related to an specific owner's location.
    """ # noqa: E501
    full_address: Optional[StrictStr] = Field(default=None, description="Full address using all components available", alias="fullAddress")
    primary_address: Optional[StrictStr] = Field(default=None, description="Primary address, stret name and street number", alias="primaryAddress")
    city: Optional[StrictStr] = Field(default=None, description="The complete city name")
    postal_code: Optional[StrictStr] = Field(default=None, description="The Zip code", alias="postalCode")
    state: Optional[StrictStr] = Field(default=None, description="The state or province")
    country: Optional[StrictStr] = Field(default=None, description="The complete country name")
    type: Optional[StrictStr] = Field(default=None, description="Type of address, Personal or Work")
    __properties: ClassVar[List[str]] = ["fullAddress", "primaryAddress", "city", "postalCode", "state", "country", "type"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Personal', 'Work']):
            raise ValueError("must be one of enum values ('Personal', 'Work')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Address from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Address from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "fullAddress": obj.get("fullAddress"),
            "primaryAddress": obj.get("primaryAddress"),
            "city": obj.get("city"),
            "postalCode": obj.get("postalCode"),
            "state": obj.get("state"),
            "country": obj.get("country"),
            "type": obj.get("type")
        })
        return _obj


